'use strict';

var path = require('path');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var path__default = /*#__PURE__*/_interopDefaultLegacy(path);

var TYPE = 'demo';
var END_TYPE = "container_".concat(TYPE, "_close");
var CLASS_WRAPPER = 'vuepress-plugin-demo-block__wrapper';
var CLASS_DISPLAY = 'vuepress-plugin-demo-block__display';
var CLASS_CODE = 'vuepress-plugin-demo-block__code';
var CLASS_FOOTER = 'vuepress-plugin-demo-block__footer';
var CLASS_APP = 'vuepress-plugin-demo-block__app';

module.exports = function (options, context) {
  return {
    name: 'demo-block-test',
    define: {
      SETTINGS: options.settings || {}
    },
    clientRootMixin: path__default["default"].resolve(__dirname, 'clientRootMixin.js'),
    enhanceAppFiles: [path__default["default"].resolve(__dirname, 'enhanceAppFile.js')],
    extendMarkdown: function extendMarkdown(md) {
      var tagNameIndex = 0;
      md.use(require("markdown-it-container"), TYPE, {
        render: function render(tokens, idx) {
          var _tokens$idx = tokens[idx],
              nesting = _tokens$idx.nesting,
              info = _tokens$idx.info;

          if (nesting === -1) {
            return "\n            </Editor>\n              </div>\n              <div class=\"".concat(CLASS_FOOTER, "\"></div>\n              </div>\n          ");
          }

          var codeStr = '';
          var configStr = '';
          var typeStr = ~info.indexOf('react') ? 'react' : ~info.indexOf('vanilla') ? 'vanilla' : 'vue';

          for (var i = idx; i < tokens.length; i++) {
            var _tokens$i = tokens[i],
                type = _tokens$i.type,
                content = _tokens$i.content,
                _info = _tokens$i.info;
            if (type === END_TYPE) break;
            if (!content) continue;

            if (type === 'fence') {
              if (_info === 'json') {
                configStr = encodeURIComponent(content);
              } else {
                codeStr = encodeURIComponent(content);
              }
            }
          }

          var tagName = "app-tag-".concat(tagNameIndex++);
          return "\n          <div\n            class=\"".concat(CLASS_WRAPPER, " ").concat(tagName, "\"\n            style=\"display: block;\"\n            data-config=\"").concat(configStr, "\"\n            data-type=\"").concat(typeStr, "\"\n            data-code=\"").concat(codeStr, "\">\n              <div class=\"").concat(CLASS_DISPLAY, "\">\n                <div class=\"").concat(CLASS_APP, "\"></div>\n              </div>\n              <div class=\"").concat(CLASS_CODE, "\">\n                <Editor code=\"").concat(codeStr, "\" tagName=\"").concat(tagName, "\">\n        ");
        }
      });
    }
  };
};
